import copy
from playfield import *


SYMBOLS = ('x', 'o')
EMPTY_SYM = '-'

class TTTGame:

    def __init__(self, p1_creator, p2_creator):
        p1 = p1_creator(my_sym=SYMBOLS[0],
                        opp_sym=SYMBOLS[1],
                        empty_sym=EMPTY_SYM)
        p2 = p2_creator(my_sym=SYMBOLS[1],
                        opp_sym=SYMBOLS[0],
                        empty_sym=EMPTY_SYM)
        self.players = [p1, p2]
        self.field = empty_field(size=3, empty_sym=EMPTY_SYM)


    def run(self):
        sequence = []
        for iter in range(4):
            player_idx = iter % 2
            current_player = self.players[player_idx]
            move = current_player.move(copy.deepcopy(self.field))
            self.field[move[0]][move[1]] = SYMBOLS[player_idx]
            print(self.field)
            sequence.append((iter, player_idx, move))
        return 'Winner is 1', sequence